=== debian/changelog ===
modsecurity (3.0.14-1) unstable; urgency=medium

  [ Alberto Gonzalez Iniesta ]
  * d/control: Update Maintainer/Uploaders

  [ Ervin Hegedüs ]
  * New upstream version 3.0.14
    Fixes CVE-2025-27110

 -- Ervin Hegedüs <airween@gmail.com>  Tue, 25 Feb 2025 16:58:02 +0100
