=== debian/control ===
Source: modsecurity
Priority: optional
Maintainer: Ervin Hegedus <airween@gmail.com>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 13), libyajl-dev, libgeoip-dev, libxml2-dev, libpcre2-dev, libcurl4-gnutls-dev, liblua5.3-dev, libmaxminddb-dev, libfuzzy-dev, pkgconf, debhelper-compat (= 13)
Standards-Version: 4.6.1
Section: libs
Uploaders: Alberto Gonzalez Iniesta <agi@inittab.org>
Homepage: https://www.modsecurity.org/
Vcs-Git: https://salsa.debian.org/agi/modsecurity.git

Package: libmodsecurity-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmodsecurity3t64 (= ${binary:Version}), ${misc:Depends}
Description: ModSecurity v3 library component (development files)
 Libmodsecurity is one component of the ModSecurity v3 project. The library
 codebase serves as an interface to ModSecurity Connectors taking in web
 traffic and applying traditional ModSecurity processing. In general, it
 provides the capability to load/interpret rules written in the ModSecurity
 SecRules format and apply them to HTTP content provided by your application
 via Connectors.
 .
 This package includes the development support files.

Package: libmodsecurity3t64
Provides: ${t64:Provides}
Replaces: libmodsecurity3
Breaks: libmodsecurity3 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ModSecurity v3 library component
 Libmodsecurity is one component of the ModSecurity v3 project. The library
 codebase serves as an interface to ModSecurity Connectors taking in web
 traffic and applying traditional ModSecurity processing. In general, it
 provides the capability to load/interpret rules written in the ModSecurity
 SecRules format and apply them to HTTP content provided by your application
 via Connectors.
